<template>
  <div class="app-container">
    <!-- 新增 -->
    <el-button type="primary" icon="el-icon-plus" size="mini" @click="getDialog()"
      v-hasPermi="['operation:channel:add']">
      新增频道配置
    </el-button>
    <!-- 列表 -->
    <el-table :data="tableData" v-loading="loading">
      <el-table-column label="序号" align="center" type="index" />
      <el-table-column label="频道配置名称" prop="name" align="center" />
      <el-table-column label="部署形式" prop="type" align="center" :formatter="typeFormatter" />
      <el-table-column label="设备" prop="deviceIds" align="center" :formatter="devFormatter"
        show-overflow-tooltip />
      <el-table-column label="操作" align="center">
        <template slot-scope="scope">
          <el-button type="text" @click="getDialog(scope.row, scope.$index)"
            v-hasPermi="['operation:channel:edit']">编辑</el-button>
          <el-button v-if="scope.$index !== 0" type="delete" @click="getDelete(scope.row)"
            v-hasPermi="['operation:channel:delete']">
            删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 弹窗 -->
    <el-dialog :visible.sync="dialogVisible" :title="title" width="950px">
      <el-form label-width="auto">
        <el-form-item v-if="index !== 1" label="频道配置名称：" style="width: 300px">
          <el-input v-model="dialogForm.name" placeholder="请输入规则名称" />
        </el-form-item>
        <el-form-item v-if="index !== 1" label="关联设备：">
          <el-select v-model="ids" multiple placeholder="请选择关联设备">
            <el-option v-for="item in devOptions" :key="item.label" :value="item.value.toString()"
              :label="item.label" />
          </el-select>
        </el-form-item>
        <el-form-item v-if="title === '编辑'" label="内容列表：">
          <el-table :data="list" v-loading="dialog_loading" height="489" lazy>
            <el-table-column label="序号" type="index" align="center" />
            <el-table-column label="频道名称" prop="aliasName" align="center" />
            <el-table-column label="频道封面" align="center" width="100px">
              <template slot-scope="scope">
                <el-image :src="scope.row.pic"></el-image>
              </template>
            </el-table-column>
            <el-table-column label="频道简介" prop="description" align="center" show-overflow-tooltip />
            <el-table-column label="操作" align="center">
              <template slot-scope="scope">
                <el-button type="text" @click="edit(scope)">编辑</el-button>
              </template>
            </el-table-column>
          </el-table>
        </el-form-item>
      </el-form>
      <div slot="footer" v-if="index !== 1">
        <el-button @click="cancel">取消</el-button>
        <el-button type="primary" @click="getSubmit">确定</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { channelPage, page, create, editPage, getRemove, devList } from '@/api/operation/channel'
export default {
  name: 'Channel',
  dicts: ['deployment_form'],
  data() {
    return {
      // 遮罩层
      loading: false,
      dialog_loading: false,
      // 列表
      tableData: [],
      list: [],
      // 弹窗
      dialogVisible: false,
      title: '',
      // 设备
      devOptions: [],
      allDevOptions: [],
      // 表单
      form: {
        pageNum: 1,
        pageSize: 10
      },
      index: 0,
      dialogForm: {},
      ids: []
    };
  },
  watch: {
    ids(val) {
      this.dialogForm.deviceIds = val.join(',')
    }
  },
  mounted() {
    this.getDevList()
    this.getList()
  },
  methods: {
    // 列表
    getList() {
      this.loading = true
      page(this.form).then(res => {
        if (res.code === 0) {
          this.tableData = res.data
          this.loading = false
        }
      })
    },

    // 全部设备
    getDevList() {
      devList(1).then(res => {
        if (res.code === 0) {
          this.allDevOptions = []
          res.data.map(i => {
            this.allDevOptions.push({
              value: i.clientTypeId,
              label: i.name
            })
          })
        }
      })
    },

    // 编辑
    edit(e) {
      this.$router.push({
        path: `/operation/channel/detail`,
        query: {
          channelId: e.row.id,
          audioType: e.row.channelType,
          index: e.$index
        }
      })
    },

    // 删除
    getDelete(row) {
      this.$confirm(`是否删除${row.name}?`, '提示', {
        type: 'warning'
      }).then(() => {
        getRemove(row.id).then(res => {
          if (res.code === 0) {
            this.$message.success('删除成功！')
            this.getList()
          }
        })
      })
    },

    // 弹窗
    getDialog(row, index) {
      this.dialogVisible = true
      this.index = index + 1

      // 新增 / 编辑时的设备
      let type = row ? 1 : 0
      devList(type).then(res => {
        if (res.code === 0) {
          this.devOptions = []
          res.data.map(i => {
            this.devOptions.push({
              value: i.clientTypeId,
              label: i.name
            })
          })
        }
      })

      if (row) {
        this.title = '编辑'
        this.dialogForm = row
        if (this.index !== 1) {
          this.ids = this.dialogForm.deviceIds.split(',')
        }
        channelPage(row.id).then(res => {
          if (res.code === 0) {
            this.list = res.data
            this.dialog_loading = false
          }
        })
      } else {
        this.ids = []
        this.dialogForm = {}
        this.title = '新增'
      }
    },

    // 创建
    getSubmit() {
      if (this.title === '编辑') {
        editPage(this.dialogForm).then(res => {
          if (res.code === 0) {
            this.$message.success('修改成功！')
            this.dialogVisible = false
            this.getList()
          }
        })
      } else {
        create({
          name: this.dialogForm.name,
          deviceIds: this.dialogForm.deviceIds,
          type: 1
        }).then(res => {
          if (res.code === 0) {
            this.$message.success('新增成功！')
            this.dialogVisible = false
            this.getList()
          }
        })
      }
    },

    // 取消
    cancel() {
      this.dialogVisible = false
      this.getList()
    },

    // 字典翻译
    typeFormatter(row) {
      return this.selectDictLabel(this.dict.type.deployment_form, row.type)
    },
    devFormatter(row) {
      return row.deviceIds ? row.deviceIds.split(',').map(i => this.selectDictLabel(this.allDevOptions, i)).join(',') : ''
    }
  },
};
</script>